Loading...
Searching...
No Matches
Sip_require

## Macros

#define | sip_require(sip)
| Access a SIP Require header structure sip_require_t from sip_t.
#define | SIP_REQUIRE_INIT()
| Initializer for structure sip_require_t.
#define | SIPTAG_REQUIRE(x)
| Tag list item for pointer to a Require header structure sip_require_t.
#define | SIPTAG_REQUIRE_REF(x)
| Tag list item for reference to a Require header pointer.
#define | SIPTAG_REQUIRE_STR(s)
| Tag list item for string with Require header value.
#define | SIPTAG_REQUIRE_STR_REF(x)
| Tag list item for reference to a Require header string.

## Typedefs

typedef msg_list_t | sip_require_t
| @

## Functions

issize_t | sip_require_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Require header.
issize_t | sip_require_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Require header.
sip_require_t * | sip_require_init (sip_require_t x[1])
| Initialize a structure sip_require_t.
int | sip_is_require (sip_header_t const *header)
| Test if header object is instance of sip_require_t.
sip_require_t * | sip_require_dup (su_home_t *home, sip_require_t const *hdr))
| Duplicate a list of Require header header structures sip_require_t.
sip_require_t * | sip_require_copy (su_home_t *home, sip_require_t const *hdr))
| Copy a list of Require header header structures sip_require_t.
sip_require_t * | sip_require_make (su_home_t *home, char const *s))
| Make a Require header structure sip_require_t.
sip_require_t * | sip_require_format (su_home_t *home, char const *fmt,...)))
| Make a Require header from formatting result.

## Variables

msg_hclass_t | sip_require_class []
| Header class for Require header.
tag_typedef_t | siptag_require
| Tag for Require header object.
tag_typedef_t | siptag_require_str
| Tag for string with Require header value.

## Detailed Description

## Macro Definition Documentation

## SIP_REQUIRE_INIT

#define SIP_REQUIRE_INIT | ( |  | ) |

Initializer for structure sip_require_t.

A static sip_require_t structure for Require header must be initialized with the SIP_REQUIRE_INIT() macro. For instance,

sip_require_t sip_require = SIP_REQUIRE_INIT;
sip_require
#define sip_require(sip)
Access a SIP Require header structure sip_require_t from sip_t.
Definition sip_protos.h:7985
SIP_REQUIRE_INIT
#define SIP_REQUIRE_INIT()
Initializer for structure sip_require_t.
Definition sip_protos.h:8002
sip_require_t
msg_list_t sip_require_t
@
Definition sip.h:185

## SIPTAG_REQUIRE

#define SIPTAG_REQUIRE | ( |  | x | ) |

Tag list item for pointer to a Require header structure sip_require_t.

The SIPTAG_REQUIRE() macro is used to include a tag item with a pointer to a sip_require_t structure in a tag list.

Parameters

  x | pointer to a sip_require_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REQUIRE_REF().

## SIPTAG_REQUIRE_STR

#define SIPTAG_REQUIRE_STR | ( |  | s | ) |

Tag list item for string with Require header value.

The SIPTAG_REQUIRE_STR() macro is used to include a tag item with a string containing value of a sip_require_t header in a tag list.

Parameters

  s | pointer to a string containing Require header value, or NULL.

The string in SIPTAG_REQUIRE_STR() can be converted to a sip_require_t header structure by giving the string s has second argument to function sip_require_make().

The corresponding tag taking reference parameter is SIPTAG_REQUIRE_STR_REF().

## Typedef Documentation

## sip_require_t

typedef msg_list_t sip_require_t

@

The Require header is used by clients to tell user agent servers about options that the client expects the server to support in order to properly process the request. Its syntax is defined in RFC 3261 as follows:

Require = "Require" HCOLON option-tag *(COMMA option-tag)

The parsed Require header is stored in sip_require_t structure.

The structure sip_require_t contains representation of an Require header.

The sip_require_t is defined as follows:

typedef struct msg_list_s
{
msg_common_t k_common[1]; // Common fragment info
msg_list_t *k_next; // Link to next header
msg_param_t *k_items; // List of items
} sip_require_t;
msg_list_t
struct msg_list_s msg_list_t
msg_common_t
struct msg_common_s msg_common_t
msg_list_s
msg_list_s::k_common
msg_common_t k_common[1]
msg_list_s::k_next
msg_list_t * k_next
msg_list_s::k_items
msg_param_t * k_items

## Function Documentation

## sip_is_require()

int sip_is_require | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_require_t.

Check if the header class is an instance of Require header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header require
  0 | (false) otherwise

## sip_require_copy()

sip_require_t * sip_require_copy | ( | su_home_t * | home,
|  | sip_require_t const * | hdr )

inline

Copy a list of Require header header structures sip_require_t.

The function sip_require_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  require = sip_require_copy(home, sip->sip_require);
  sip_require_copy
  sip_require_t * sip_require_copy(su_home_t *home, sip_require_t const *hdr))
  Copy a list of Require header header structures sip_require_t.
  Definition sip_protos.h:8132

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_require_dup()

sip_require_t * sip_require_dup | ( | su_home_t * | home,
|  | sip_require_t const * | hdr )

inline

Duplicate a list of Require header header structures sip_require_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  require = sip_require_dup(home, sip->sip_require);
  sip_require_dup
  sip_require_t * sip_require_dup(su_home_t *home, sip_require_t const *hdr))
  Duplicate a list of Require header header structures sip_require_t.
  Definition sip_protos.h:8089

Returns
  A pointer to the newly duplicated sip_require_t header structure, or NULL upon an error.

## sip_require_format()

sip_require_t * sip_require_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Require header from formatting result.

Make a new sip_require_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_require_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_require_init()

sip_require_t * sip_require_init | ( | sip_require_t | x[1] | ) |

inline

Initialize a structure sip_require_t.

An sip_require_t structure for Require header can be initialized with the sip_require_init() function/macro. For instance,

sip_require_t sip_require;
sip_require_init(&sip_require);
sip_require_init
sip_require_t * sip_require_init(sip_require_t x[1])
Initialize a structure sip_require_t.
Definition sip_protos.h:8020

## sip_require_make()

sip_require_t * sip_require_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Require header structure sip_require_t.

The function sip_require_make() makes a new sip_require_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_require_t header structure, or NULL upon an error.

## Variable Documentation

## sip_require_class

msg_hclass_t sip_require_class[]

extern

Header class for Require header.

The header class sip_require_class defines how a SIP Require header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_require_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.